<?php



/**



* PrayerCenter Component



* 



* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL



*



*/



// Check to ensure this file is included in Joomla!



defined('_JEXEC') or die( 'Restricted access' );



class PrayerCenterModelManageDevotions extends JModelList



{



	/**



	 * @var int



	 */



	var $_id = null;



	/**



	 * @var array



	 */



	var $_data = null;



	/**



	 * Constructor



	 *



	 * @since 1.5



	 */



	function __construct($config = array())



	{



		$array = JRequest::getVar('cid', array(0), '', 'array');



		$edit	= JRequest::getVar('edit',true);



		if($edit)



			$this->setId((int)$array[0]);



		if (empty($config['filter_fields'])) {



			$config['filter_fields'] = array(



				'id', 'a.id',



				'name', 'a.name',



        'feed', 'a.feed',



				'published', 'a.published',



        'catid', 'a.catid',



				'checked_out', 'a.checked_out',



				'checked_out_time', 'a.checked_out_time',



				'ordering', 'a.ordering'



			);



    }



		parent::__construct($config);



	}



	function setId($id)



	{



		$this->_id		= $id;



		$this->_data	= null;



	}



	protected function getStoreId($id = '')



	{



		// Compile the store id.



		$id .= ':' . $this->getState('filter.search');



		$id .= ':' . $this->getState('filter.access');



		$id .= ':' . $this->getState('filter.published');



		$id .= ':' . $this->getState('filter.category_id');



		$id .= ':' . $this->getState('filter.language');



		return parent::getStoreId($id);



	}



	protected function populateState($ordering = null, $direction = null)



	{



		$app = JFactory::getApplication('administrator');



  	$search = $this->getUserStateFromRequest( $this->context.'.filter.search', 'filter_search' );



  	$this->setState('filter.search', $search);



		$published = $this->getUserStateFromRequest($this->context.'.filter.published', 'filter_published', '');



		$this->setState('filter.published', $published);



		$accessId = $this->getUserStateFromRequest($this->context . '.filter.access', 'filter_access', null, 'int');



		$this->setState('filter.access', $accessId);



		$state = $this->getUserStateFromRequest($this->context . '.filter.published', 'filter_published', '', 'string');



		$this->setState('filter.published', $state);



		$categoryId = $this->getUserStateFromRequest($this->context . '.filter.category_id', 'filter_category_id', null);



		$this->setState('filter.category_id', $categoryId);



		$language = $this->getUserStateFromRequest($this->context . '.filter.language', 'filter_language', '');



		$this->setState('filter.language', $language);



		// force a language



		$forcedLanguage = $app->input->get('forcedLanguage');



		if (!empty($forcedLanguage))



		{



			$this->setState('filter.language', $forcedLanguage);



			$this->setState('filter.forcedLanguage', $forcedLanguage);



		}



		$tag = $this->getUserStateFromRequest($this->context . '.filter.tag', 'filter_tag', '');



		$this->setState('filter.tag', $tag);



		// Load the parameters.



		$params = JComponentHelper::getParams('com_newsfeeds');



		$this->setState('params', $params);



		// List state information.



		parent::populateState('a.name', 'asc');



	}



	protected function getListQuery()



	{



		// Create a new query object.



		$db		= $this->getDbo();



		$query	= $db->getQuery(true);



		$user	= JFactory::getUser();



		// Select the required fields from the table.



		$query->select(



			$this->getState(



				'list.select',



				'a.id, a.name, a.feed, a.catid, a.checked_out, a.checked_out_time' .



				', a.published, a.ordering'



			)



		);



		$query->from('#__prayercenter_devotions AS a');



		// Join over the users for the checked out user.



		$query->select('uc.name AS editor');



		$query->join('LEFT', '#__users AS uc ON uc.id=a.checked_out');



		// Join over the asset groups.



//		$query->select('ag.title AS access_level')



//			->join('LEFT', '#__viewlevels AS ag ON ag.id = a.access');



		// Join over the categories.



		$query->select('c.title AS category_title')



			->join('LEFT', '#__categories AS c ON c.id = a.catid');



		// Filter by access level.



		if ($access = $this->getState('filter.access')) {



//			$query->where('a.access = ' . (int) $access);



		}



		// Implement View Level Access



		if (!$user->authorise('core.admin'))



		{



			$groups	= implode(',', $user->getAuthorisedViewLevels());



//			$query->where('a.access IN ('.$groups.')');



		}



		// Filter by published state



		$published = $this->getState('filter.published');



		if (is_numeric($published)) {



			$query->where('a.published = ' . (int) $published);



		}



		elseif ($published === '') {



			$query->where('(a.published = 0 OR a.published = 1)');



		}



		// Filter by search in name.



		$search = $this->getState('filter.search');



		if (!empty($search)) {



			if (stripos($search, 'id:') === 0) {



				$query->where('a.id = '.(int) substr($search, 3));



			}



			elseif (stripos($search, 'name:') === 0) {



				$search = $db->Quote('%'.$db->escape(substr($search, 7), true).'%');



				$query->where('(uc.name LIKE '.$search.' OR uc.username LIKE '.$search.')');



			}



			else {



				$search = $db->Quote('%'.$db->escape($search, true).'%');



				$query->where('(a.name LIKE '.$search.')');



			}



		}



		// Add the list ordering clause.



		$orderCol	= $this->state->get('list.ordering');



		$orderDirn	= $this->state->get('list.direction');



		if ($orderCol == 'a.ordering') {



			$orderCol = 'category_title '.$orderDirn.', a.ordering';



		}



		$query->order($db->escape($orderCol.' '.$orderDirn));



		//echo nl2br(str_replace('#__','jos_',$query));



		return $query;



	}



}