<?php
/**
* PrayerCenter Component for Joomla
* By Mike Leeper
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*
*/
// no direct access
defined('_JEXEC') or die('Restricted access');

global $prayercenteradmin;

// Include the component HTML helpers.
JHtml::addIncludePath(JPATH_COMPONENT . '/helpers/html');

JHtml::_('bootstrap.tooltip');
JHtml::_('behavior.multiselect');
JHtml::_('formbehavior.chosen', 'select');

$newtopicarray = $prayercenteradmin->PCgetTopics();
$user		= JFactory::getUser();
$userId		= $user->get('id');
$listOrder	= $this->escape($this->state->get('list.ordering'));
$listDirn	= $this->escape($this->state->get('list.direction'));
$canOrder	= $user->authorise('core.edit.state', 'com_prayercenter.managereq');
$saveOrder	= $listOrder == 'a.ordering';
if ($saveOrder)
{
	$saveOrderingUrl = 'index.php?option=com_prayercenter&task=requests.saveOrderAjax&tmpl=component';
	JHtml::_('sortablelist.sortable', 'adminList', 'adminForm', strtolower($listDirn), $saveOrderingUrl);
}

$sortFields = $this->getSortFields();

$siteApp = JFactory::getApplication( 'site' );
$siteTemplate = $siteApp->getTemplate();
if($siteTemplate === 'hathor') {
	echo '<style type="text/css">
	.row-striped, .table-striped,.row-fluid {
		font-size: 14px !important;	line-height: 2.2em;
	}
	</style>';
}
?>
	<form action="<?php echo JRoute::_('index.php?option=com_prayercenter&view=managereq'); ?>" method="post" name="adminForm" id="adminForm">
		<?php if (!empty( $this->sidebar)) : ?>
			<div id="j-sidebar-container" class="span2">
				<?php echo $this->sidebar; ?>
			</div>
			<div id="j-main-container" class="span10">
		<?php else : ?>
			<div id="j-main-container">
		<?php endif;?>
		<?php echo JLayoutHelper::render('joomla.searchtools.default', array('view' => $this)); ?>
		<div class="clearfix"></div>
		<?php if (empty($this->items)) : ?>
			<div class="alert alert-no-items">
				<?php echo JText::_('JGLOBAL_NO_MATCHING_RESULTS'); ?>
			</div>
		<?php else : ?>
		<table class="table table-striped" id="adminList">
	   <thead>
      	<tr>
			<th width="1%" class="hidden-phone">
				<?php echo JHtml::_('grid.checkall'); ?>
			</th>
			<th class="hidden-phone">
				<?php echo JHTML::_('searchtools.sort',   'Requester', 'a.requester', $listDirn, $listOrder, 'manage_req' ); ?>
			</th>
			<th class="hidden-phone">
				<?php echo JHTML::_('searchtools.sort',   'Email Address', 'a.email', $listDirn, $listOrder, 'manage_req' ); ?>
			</th>
			<th class="hidden-phone">
				<?php echo JHTML::_('searchtools.sort',   'Topic', 'a.topic', $listDirn, $listOrder, 'manage_req' ); ?>
			</th>
			<th class="hidden-phone">
				<?php echo JHTML::_('searchtools.sort',   'Title', 'a.title', $listDirn, $listOrder, 'manage_req' ); ?>
			</th>
			<th class="hidden-phone">
				<?php echo JHTML::_('searchtools.sort',   'Request', 'a.request', $listDirn, $listOrder, 'manage_req' ); ?>
			</th>
			<th class="hidden-phone">
				<?php echo JHTML::_('searchtools.sort',   'Date / Time', 'a.datetime', $listDirn, $listOrder, 'manage_req' ); ?>
			</th>
			<th class="hidden-phone">
				<?php echo JHTML::_('searchtools.sort',   'Display', 'a.displaystate', $listDirn, $listOrder, 'manage_req' ); ?>
			</th>
			<th width="5%" class="hidden-phone nowrap">
				<?php echo JHTML::_('searchtools.sort',   'Published', 'a.publishstate', $listDirn, $listOrder, 'manage_req' ); ?>
			</th>
			<th width="5%" class="hidden-phone nowrap">
				<?php echo JHTML::_('searchtools.sort',   'Archived', 'a.archivestate', $listDirn, $listOrder, 'manage_req' ); ?>
			</th>
			<th width="5%" class="hidden-phone nowrap">
				<?php echo JHTML::_('searchtools.sort',   'ID', 'a.id', $listDirn, $listOrder, 'manage_req' ); ?>
			</th>
  	  	</tr>
      </thead>
			<tfoot>
				<tr>
					<td colspan="10">
						<?php echo $this->pagination->getListFooter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
		<?php
		foreach ($this->items as $i => $item) {
			$ordering   = ($listOrder == 'a.ordering');
			$request = $item->request;
			$request = strip_tags($request,"<i><strong><u><em><strike>");
			$request = stripslashes($request);
			if (strlen($request) > 50) $request = substr($request, 0 , 48) . " ...";
			$ordering   = ($listOrder == 'a.ordering');
			$canCheckin = $user->authorise('core.manage', 'com_checkin') || $item->checked_out == $user->get('id') || $item->checked_out == 0;
			$canChange  = true;//$user->authorise('core.edit.state', 'com_livingword.manageplans.' . $item->catid) && $canCheckin;
			?>
			<tr class="row<?php echo $i % 2; ?>" sortable-group-id="<?php echo md5($item->id);?>">
			<td class="center hidden-phone" width="5">
        	<?php echo JHtml::_('grid.id', $i, $item->id); ?>
			</td>
			<td class="hidden-phone center"><?php echo $item->requester; ?></td>
			<td class="hidden-phone center"><?php echo $item->email; ?></td>
			<td class="hidden-phone center"><?php echo $newtopicarray[$item->topic+1]['text']; ?></td>
			<td class="hidden-phone center"><?php echo JText::_($item->title); ?></td>
			<td class="hidden-phone center">
			<?php echo $this->escape(JText::_($request)); ?>
			<?php if ($item->checked_out) : ?><br />
				<?php echo JHtml::_('jgrid.checkedout', $i, $item->editor, $item->checked_out_time, '', $canCheckin);  ?>
			<?php endif; ?>
			</td>
			<td class="hidden-phone center"><?php echo $item->datetime; ?></td>
			<?php
			$displayimg = array();
			$displayimg[] = '<a class="btn btn-micro active" rel="tooltip"';
			if ($item->displaystate) {
				$displayimg[] = ' href="javascript:void(0);" onclick="return listItemTask(\'cb'.$i.'\', \'prayercenter.hidereq\')"';
				$displayimg[] = ' title="'.addslashes(htmlspecialchars(JText::_('Hide Request'))).'">';
				$displayimg[] = '<i class="icon-publish">';
			} else {
				$displayimg[] = ' href="javascript:void(0);" onclick="return listItemTask(\'cb'.$i.'\', \'prayercenter.displayreq\')"';
				$displayimg[] = ' title="'.addslashes(htmlspecialchars(JText::_('Display Request'))).'">';
				$displayimg[] = '<i class="icon-unpublish">';
			} 
			$displayimg[] = '</i>';
			$displayimg[] = '</a>';
			$publishimg = array();
			$publishimg[] = '<a class="btn btn-micro active" rel="tooltip"';
			if ($item->publishstate) {
				$publishimg[] = ' href="javascript:void(0);" onclick="return listItemTask(\'cb'.$i.'\', \'prayercenter.unpublish\')"';
				$publishimg[] = ' title="'.addslashes(htmlspecialchars(JText::_('Unpublish Request'))).'">';
				$publishimg[] = '<i class="icon-publish">';
			} else {
				$publishimg[] = ' href="javascript:void(0);" onclick="return listItemTask(\'cb'.$i.'\', \'prayercenter.publish\')"';
				$publishimg[] = ' title="'.addslashes(htmlspecialchars(JText::_('Publish Request'))).'">';
				$publishimg[] = '<i class="icon-unpublish">';
			} 
			$publishimg[] = '</i>';
			$publishimg[] = '</a>';
			$archiveimg = array();
			$archiveimg[] = '<a class="btn btn-micro active" rel="tooltip"';
			if ($item->archivestate) {
				$archiveimg[] = ' href="javascript:void(0);" onclick="return listItemTask(\'cb'.$i.'\', \'prayercenter.unarchive\')"';
				$archiveimg[] = ' title="'.addslashes(htmlspecialchars(JText::_('Unarchive Request'))).'">';
				$archiveimg[] = '<i class="icon-publish">';
			} else {
				$archiveimg[] = ' href="javascript:void(0);" onclick="return listItemTask(\'cb'.$i.'\', \'prayercenter.archive\')"';
				$archiveimg[] = ' title="'.addslashes(htmlspecialchars(JText::_('Archive Request'))).'">';
				$archiveimg[] = '<i class="icon-unpublish">';
			} 
			$archiveimg[] = '</i>';
			$archiveimg[] = '</a>';
			?>           		
			<td class="hidden-phone center"><?php echo implode($displayimg); ?></td>
			<td class="hidden-phone center"><?php echo implode($publishimg); ?></td>
			<td class="hidden-phone center"><?php echo implode($archiveimg); ?></td>
			<td class="center hidden-phone">
			<?php echo (int)$item->id; ?>
			</td>
			</tr>
			<?php
		}
		  ?>
    </tbody>  
	</table>
	<?php endif; ?>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="boxchecked" value="0" />
	<?php echo JHTML::_( 'form.token' ); ?>
	</div></div></div></form>
	<?php
  $prayercenteradmin->PCfooter();
?>