<?php
/**
 * @package MOD_KDBIBLEVERSES for Joomla!
 * @version $Id: helper.php 2.0.3 2012-10-07 12:00:00
 * @author Terry Carter
 * @copyright (C) 2010- Kaoz Designs
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

// No direct access.
defined('_JEXEC') or die;

abstract class modKDBibleVersesHelper
{
	public static function getBibleVerse( $params )
    {
		$books = str_replace(',', "','", implode(',',$params->get("kdbv_books", "")));
		
		//VERSE QUERY
        $db = JFactory::getDbo();
		$query = $db->getQuery(true);
		
        $query->select('b.bookname, v.chapter, v.verse, v.versetext');
        $query->from('#__mod_kdbibleverses AS v');
		$query->join('LEFT','#__mod_kdbiblebooks AS b ON v.book = b.bookid');
		
		//LIMIT TO SPECIFIC BOOKS IF SET
		if($books != 'all'){
			$query->where("b.bookid IN ('$books')");
		}
		
		//RANDOMIZE IN SELECTED BOOKS
		$query->order('RAND() LIMIT 0,1');
		$db->setQuery($query);
		
		$rows = $db->loadObjectList();
		return $rows;
    }
}
